﻿using System;
using System.Activities;
using System.Activities.DurableInstancing;
using System.Collections.Generic;
using System.Linq;
using System.ServiceModel.Activities;
using System.ServiceModel.Description;
using System.Text;
using System.Threading.Tasks;

namespace SideBySideSelfHosted
{
    class Program
    {
        static void Main(string[] args)
        {
            WorkflowService v1Service = new WorkflowService
            {
                Name = "OrderService",
                Body = new OrderServiceV1(),
                DefinitionIdentity = new WorkflowIdentity
                {
                    Name = "Order Service v1",
                    Version = new Version(1, 0, 0, 0)
                }
            };

            WorkflowServiceHost host = new WorkflowServiceHost(v1Service, new Uri("http://localhost:8080/OrderService"));

            string connectionString = @"Data Source=damirarh-nb;Initial Catalog=SqlWorkflowInstanceStore;Integrated Security=False;User ID=wf;Password=wf";
            SqlWorkflowInstanceStore instanceStore = new SqlWorkflowInstanceStore(connectionString);
            host.DurableInstancingOptions.InstanceStore = instanceStore;
            host.Description.Behaviors.Add(new ServiceMetadataBehavior() { HttpGetEnabled = true });

            host.Open();

            Console.WriteLine("Press any key to stop the service");
            Console.ReadKey();

            host.Close();
        }
    }
}
